<?php
/* Copyright 2010, 2011 Greig Sheridan
This file is part of C-ChangePHP
C-ChangePHP is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
C-ChangePHP is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with C-ChangePHP.  If not, see <http://www.gnu.org/licenses/>.
*/
require_once "PHPTelnet.php";
require_once "config.php";
require_once "c-bus_common.php";
session_start();
?>
<!DOCTYPE html public "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<link rel="stylesheet" type="text/css" href="_resource/cbus.css">
<title>C-Bus Control</title>
<link rel="shortcut icon" type="image/x-icon" href="_resource/favicon.ico" />

<script type="text/javascript"> 

// with thanks to:
// http://blog.jellytriangle.com/2009/12/24/fantastic-graphical-checkboxes-using-css-and-javascript/
// for the funky checkbox Javascript.


function selectApp(id,divid,what)
{
 
	if(document.getElementById(id).checked==true)
	{
		document.getElementById(id).checked = false;
		document.getElementById(divid).className = what;
	}
	else
	{
		document.getElementById(id).checked = true;
		document.getElementById(divid).className = (what + '_checked');
	}
}
</script>
</head>
<body>
<noscript><h3>Your browser does not support JavaScript! This page will not work correctly.</h3></noscript>
<?php 
if(isset($_GET["ramp"])) {
	$ramp = ($_GET["ramp"]);
	//echo "<br>We got ramp = " . $ramp . "<br>";
} else {
	$ramp = "4";
}

if(isset($_GET["level"])) {
	$level = ($_GET["level"]);
	//echo "<br>We got level = " . $level . "<br>";
} else {
	$level = "60";
}

if(isset($_GET["gettags"])) {	// Force a reload of the tags and session variables. (For easier debugging)
	session_unset();	
	read_tags();
}

if((isset($_SESSION['got_tags'])) && (isset($_SESSION['Project'])) && (isset($_SESSION['network']))) {
	// Then we're good to go
} else {
	read_tags();
	$_SESSION['got_tags'] = 1;
}

if(isset($_GET["page"])) {
	$page = ($_GET["page"]);
	//echo "<br>We saw Page, so must be on the Table View"<br>";
} else {
	$page = 0;
}

If ($page<>0) {
	$page = 1;
}

if(isset($_POST["page"]))
	{
	// Now redirect back to itself:
	$self = $_SERVER['SCRIPT_NAME'];
	if ($page == 1) {
		header("Location: $self?ramp=" . $ramp . "&level=" . $level . "&page=0");
	} else {
		header("Location: $self?ramp=" . $ramp . "&level=" . $level . "&page=1");
	}
}

if(!isset($_POST["state"])) {
	// "state" was NOT set. The user did NOT submit the form to get to this point.
	// This section runs when the page was loaded 'cleanly', from either a Refresh, a Re-draw, or anew
	// It queries the bus (immediately beneath this comment), then draws the table to the page, then ends, waiting for
	// the user to press a button.

	read_bus("56");	// This returns after having read from the 'bus with all of the Group values ready for the code below to format and display. 
					// If an empty string (e.g. "") is passed, func read_bus will query *ALL* networks and apps from the tags.XML file
					// If only an App (e.g. "56") is specified, func read_bus will pad with <Project> and <Network> from config.php
					// If Network and App (e.g. "254/56") are specified, func read_bus will pad with <Project> from config.php
					// If Project, Net and App (e.g. "19P/254/56") are specified, func read_bus will not pad
					// If an entire command string is specified (e.g. "get 19P/254/56/* level"), func read_bus will transmit it verbatim

					// Multiple commands (e.g. "56,254/202,get 19P/254/56/* level") can be passed here, each comma-separated. 
					// They will be processed within the same Telnet session to the bus, but treated individually and subject to the formatting as outlined above.
	?>

	<div id="container">

		<form action="" method="post">
		
			<div id="menu">
			<p><input type="submit" name="page" value="<?php if ($page == "1")  {echo "Picture View";} else {echo "Table View";} ?>"></p>
			<hr>
			<p><input type="submit" name="state" value="redraw"></p>
			<hr>
			<br>
			<p><input type="submit" name="state" value="on"></p>
			<br>
			<p><input type="submit" name="state" value="off"></p> 
			<br>
			<hr>
			<p>Ramp to</p>
			<br>
			<select name="level">
				<option value="00"  <?php if ($level == "0")   {echo "selected";}?>  >OFF</option>
				<option value="10"  <?php if ($level == "10")  {echo "selected";}?>  >10%</option>
				<option value="20"  <?php if ($level == "20")  {echo "selected";}?>  >20%</option>
				<option value="30"  <?php if ($level == "30")  {echo "selected";}?>  >30%</option>
				<option value="40"  <?php if ($level == "40")  {echo "selected";}?>  >40%</option>
				<option value="50"  <?php if ($level == "50")  {echo "selected";}?>  >50%</option>
				<option value="60"  <?php if ($level == "60")  {echo "selected";}?>  >60%</option>
				<option value="70"  <?php if ($level == "70")  {echo "selected";}?>  >70%</option>
				<option value="80"  <?php if ($level == "80")  {echo "selected";}?>  >80%</option>
				<option value="90"  <?php if ($level == "90")  {echo "selected";}?>  >90%</option>
				<option value="100" <?php if ($level == "100") {echo "selected";}?>  >100%</option>
			</select>
			<br />
			
			<p>or</p>
			<p>specify 0-255</p>
			<p><input type="text" name="specify" value="" maxlength="3" size="3"></p>
			
			<p>over</p>
			
			<select name="ramp">
				<option value="0"   <?php if ($ramp == "0")   {echo "selected";}?>   >Instant</option>
				<option value="4"   <?php if ($ramp == "4")   {echo "selected";}?>   >4 s</option>
				<option value="8"   <?php if ($ramp == "8")   {echo "selected";}?>   >8 s</option>
				<option value="12"  <?php if ($ramp == "12")  {echo "selected";}?>  >12 s</option>
				<option value="16"  <?php if ($ramp == "16")  {echo "selected";}?>  >16 s</option>				
				<option value="20"  <?php if ($ramp == "20")  {echo "selected";}?>  >20 s</option>
				<option value="40"  <?php if ($ramp == "40")  {echo "selected";}?>  >40 s</option>
				<option value="60"  <?php if ($ramp == "60")  {echo "selected";}?>  >60 s</option>
				<option value="120" <?php if ($ramp == "120") {echo "selected";}?> >120 s</option>								
			</select>
			<br><br>
			<p><input type="submit" name="state" value="ramp"></p>
			<br>
			
			</div> <!-- Menu -->
		
			<?php
			if ($page == 0) {
				?>
				<div id="building">
				<img src="_resource/house.gif" />

				<!--</div>  building stays OPEN. all of the columns and rooms fall within the building div/zone -->
				<div id="column1">
					<!-- SYNTAX display(Group address, room name, width, height) -->
					<?php display(254,56,33,"UpstairsL", 185,160)?>
					<?php display(254,56,34,"DownstairsL", 150,160)?>
				</div> <!-- Column1 -->
		
				<div id="column2">
					<?php display(254,56,49,"UpstairsR", 205,160)?>
					<?php display(254,56,35,"DownstairsR",155,155)?>
				</div> <!-- Column2 -->
			</div> <!-- building -->
	
			<div id="others">
					<?php buttons(254,56,38,"Group38",1)?>
					<?php buttons(254,56,20,"Group20",0)?>
			</div> <!-- Others --> 
	
			<div style="display:none">
				<p><input type="checkbox" name="channel[]" value="56/33" id="select_33">Group33</p>
				<p><input type="checkbox" name="channel[]" value="56/34" id="select_34">Group34</p>
				<p><input type="checkbox" name="channel[]" value="56/35" id="select_35">Group35</p>
				<p><input type="checkbox" name="channel[]" value="56/49" id="select_49">Group49</p>
				<!-- Not selectable: -->
				<p><input type="checkbox" name="channel[]" value="56/20" id="select_20" disabled>Group20</p>
				<p><input type="checkbox" name="channel[]" value="56/38" id="select_38" disabled>Group38</p>
			</div> <!-- Invisible section of the menu -->
		
			<?php } else {
				//echo ("This is the table view");
				?>
				<div id="table_div">
					<table border=1>
					<tr>
						<td width=10%>Network</td>
						<td width=10%>App</td>
						<td width=15%>App Name</td>
						<td width=10%>Group Address</td>
						<td width=40%>Label</td>
						<td width=10%>Value</td>
						<td width=15%>Selected</td>
					</tr>
					<?php
					// This is where we run through the array and populate the table
					$Networks = $_SESSION["Nets"];
					$Apps = $_SESSION["Apps"];
					$Names = $_SESSION["AppNames"];
					if (isset($_SESSION["Zones"])){
						$Zones = $_SESSION["Zones"];
					}
					foreach ($Networks as &$NetNum) {	//Loop through all of the available networks
						foreach ($Apps[$NetNum] as &$AppNum) {	//Loop through all of the available applications
							//echo ("Appnum Value is " . $AppNum . " and name = ". $Names[$AppNum] . "</br>");
							for ($loop = 0; $loop < 255; $loop++) {	// Read all of the groups in this App
								if (isset ($_SESSION["tag[$NetNum][$AppNum][$loop]"])) {	// Only print those that have a name attached
									echo ("<tr>");
									echo ("	<td>" . $NetNum . "</td>");
									echo ("	<td>" . $AppNum . "</td>");
									echo (" <td>" . $Names[$NetNum][$AppNum] . "</td>");
									echo ("	<td>" . $loop . "</td>");
				
									// Use tag names from Comfortfile if AppNum = 1
									if (($_SESSION["tag[$NetNum][$AppNum][$loop]"] == "Group " . $loop) && ($AppNum == "1") && isset($Zones)) {
										echo ("	<td>" . $Zones[($loop-1)] . "*" . "</td>");
									} else {
										echo ("	<td>" . $_SESSION["tag[$NetNum][$AppNum][$loop]"] . "</td>");
									}					
									//echo ("	<td>" . $_SESSION["tag[$NetNum][$AppNum][$loop]"] . "</td>"); //This line retired by Comfort Zone code 5May2011
									if (isset ($status[$NetNum][$AppNum][$loop])){
										echo ("	<td>" . $status[$NetNum][$AppNum][$loop] . "</td>");					
									} else {
										echo ("	<td>-</td>");					
									}
									//Remove 'select' check-box from AppNum 1 (Security) Groups:
									if ($AppNum != "1") {
										echo ("	<td><input type=\"checkbox\" name=\"channel[]\" value=\"" . $AppNum . "/" . $loop . "\"></td>");
									} else {
										echo ("<td></td>");
									}
									echo ("</tr>");
								}
							} 
						}
					}
					?>
					</table>
				</div> <!-- table_div -->
				<br><br><br><br>
				<?php
			}
			?>
			</form>
		<?php
} else {
	// "state" WAS set. The user submitted the form on the page - so we have a change to send to the bus.
	// Let's find out what button was pressed and what (if any) of the other fields were completed (e.g. check-boxes, "specify", and 
	// the "ramp (time)" or "intensity (percentage)" selections.
	
	if (isset($_POST["ramp"])) {
		$ramp = ($_POST["ramp"]);   // This is to be echoed back to the next page
		$tx_ramp = ($_POST["ramp"]);// ... whilst this is what we transmit
	}
	if ($ramp == "") {
		$ramp= '0';
		$tx_ramp = '0';
	}
	
	$specify = "";
	
	switch ($_POST['state']) {
			case "on" :
				$tx_level = '100';
				$tx_ramp = '0';
			break;	
			case "off" :
				$tx_level = '0';
				$tx_ramp = '0';
			break;	
			case "ramp" :
				if (isset($_POST["level"])) {
					$level = ($_POST["level"]);	// Like above for 'ramp' - we need to remember this to pass back to the next page
					$tx_level = ($_POST["level"]);	// ... and this is the value we transmit to the bus.
				}
				if ($level == "") {
					$level = '0';
					$tx_level = '0';
				}
				// "Specify" overrides the value you might have selected on the drop-down
				if (strlen ($_POST["specify"])) {
					$specify = ($_POST["specify"]);
					//$level = ($_POST["specify"]);	// Like above for 'ramp' - we need to remember this to pass back to the next page
					if (ctype_digit($specify) ) {
						// So the value contains only digits
						if ($specify < 0) {
							$specify = 0;  //Set to 0 if value smaller than 0
						} else {
							if ($specify > 255) {
								$specify = 255;  // Set to 255 if value higher than 255
							}
						}
					} else {
						// Specify is invalid
						$specify = "";
					}
				}
			break;
			//case "redraw" :
			//	We actually handle redraw later, emptying the "$transmit" string.
			//break;
	}

	// This is where we read through the channels (checkboxes) array to see what buttons were pressed
	if (isset($_POST['channel'])){ 
			$channel = implode(",", $_POST['channel']); // format your array for use 
		} else {
			// flush the array echo "text";
			$channel = "";
		}

	// This is where we decode the channels (checkboxes) back into their command strings for transmission:
	$transmit = "";	// flush and declare the variable
	$each_ch  = "";
	if (strlen($specify)){
		//Then we use the level already in $specify (0-255)
		$binary = $specify;
	} else {
		$binary = round($tx_level * 255 / 100);
	}
	if ($binary < 1) {
		$binary = 0;
		// (Just in case - sets a minimum level)
	}
	$each_ch = strtok ($channel, ",");
	while ($each_ch !== false) {
		if (!(strpos ($each_ch, "202/") === false )){
            // Then it's the trigger group - use correct syntax:
            $transmit = $transmit . "TRIGGER EVENT //" . $project . "/" . $network . "/" . $each_ch . " " . $binary . ",";
        } else if (!(strpos ($each_ch, "203/") === false )) {
            //    echo "Enable Control command sent.";
            $transmit = $transmit . "ENABLE SET //" . $project . "/" . $network . "/" . $each_ch . " " . $binary . ",";
            //    echo $transmit;
            //    die;
        } else {
            //Everything else is OK with "ramp".
            $transmit = $transmit . "ramp //" . $project . "/" . $network . "/" . $each_ch . " " . $binary . " " . $tx_ramp . ",";
		}
        $each_ch = strtok (",");
	}
	
	if (($_POST['state']) == "redraw"){
		$transmit = ""; //Empty out anything that might be in the transmit string - causes TX to abort and we re-draw!
	}
	
	if ($transmit == ""){
		// Do nothing - no command selected
	} else {
		$RetVal = send($transmit);
		if ((strpos($RetVal, 'OK') === false)) {
			if (!(strpos($RetVal, '408 Operation failed:') === false)) {
				//C-gate isn't ready.
				echo '[C-ChangePHP] Command failed: C-Gate not sync\'d to the network. Wait and repeat';
				die;
			} else {
				echo ("<br /><br />ERROR. Return value = " . $RetVal . "<br />");
				die;
			}
		}
	}
	
	// Now redirect back to itself:
	$self = $_SERVER['SCRIPT_NAME'];
	header("Location: $self?ramp=" . $ramp . "&level=" . $level . "&page=" . $page);
}


function display($net, $app, $gp, $room, $width, $height){
	global $status;
	echo ("<div id=\"" . $room . "\" class=\"photo\" >");
	if (isset ($status[$net][$app][$gp])){
		//Then well and good
	} else {
		$status[$net][$app][$gp] = 0;
		$errcode = "Undefined group errors trapped";
	}
	if ($status[$net][$app][$gp] < 1) {
		// It's OFF 
		echo ("<a href=\"#\" onclick=\"selectApp('select_" . $gp . "', '". $room . "', 'photo')\" ><span></span><img src=\"_resource/transparent.gif\" width=" . $width . "px height=" . $height . "px alt=\"\" title=\"\" /></a>");
	} elseif (($status[$net][$app][$gp] > 0) && ($status[$net][$app][$gp] < 255)){
		//It's 'dimmed'
		echo ("<img src=\"_resource/lamp_dim.gif\" onclick=\"selectApp('select_" . $gp . "', '". $room . "', 'photo')\" style=\"left:" . ((0.5*round($width))-25) . "px; top:" . ((0.5*round($height))-25) . "px; display: inline; position: absolute;\" width=50px height=50px />");
		echo ("<a href=\"#\" onclick=\"selectApp('select_" . $gp . "', '". $room . "', 'photo')\" ><span></span><img src=\"_resource/transparent.gif\" width=" . $width . "px height=" . $height . "px alt=\"\" title=\"\" /></a>");
	} else {
		// It must be full on
		echo ("<img src=\"_resource/lamp_on.gif\" onclick=\"selectApp('select_" . $gp . "', '". $room . "', 'photo')\" style=\"left:" . ((0.5*round($width))-25) . "px; top:" . ((0.5*round($height))-25) . "px; display: inline; position: absolute;\" width=50px height=50px />");
		echo ("<a href=\"#\" onclick=\"selectApp('select_" . $gp . "', '". $room . "', 'photo')\" ><span></span><img src=\"_resource/transparent.gif\" width=" . $width . "px height=" . $height . "px alt=\"\" title=\"\" /></a>");
	}
	echo ("</div> <!-- " . $room . " -->");
}

function buttons($net, $app, $gp, $room, $enabled){
	global $status;
	$height = 40;
	$width = 80;
	echo ("<div id=\"" . $room . "\" class=\"btn\" >");	
	if (isset ($status[$net][$app][$gp])){
		//Then well and good
	} else {
		$status[$net][$app][$gp] = 0;
		$errcode = "Undefined group errors trapped";
	}
	if ($status[$net][$app][$gp] < 1) {
		// It's OFF 
		echo ("<img src=\"_resource/b_off.gif\" onclick=\"selectApp('select_" . $gp . "', '". $room . "', 'btn')\" >");
		echo ("<a href=\"#\" onclick=\"selectApp('select_" . $gp . "', '". $room . "', 'btn')\" ><p>" . $room . "</p><span></span></a>");
	} elseif (($status[$net][$app][$gp] > 0) && ($status[$net][$app][$gp] < 255)){
		//It's 'dimmed'
		echo ("<img src=\"_resource/b_dim.gif\" onclick=\"selectApp('select_" . $gp . "', '". $room . "', 'btn')\" >");		
		echo ("<a href=\"#\" onclick=\"selectApp('select_" . $gp . "', '". $room . "', 'btn')\" >" . $room . "<span></span></a>");
	} else {
		// It must be full on
		echo ("<img src=\"_resource/b_on.gif\" onclick=\"selectApp('select_" . $gp . "', '". $room . "', 'btn')\" >");		
		echo ("<a href=\"#\" onclick=\"selectApp('select_" . $gp . "', '". $room . "', 'btn')\" ><p>" . $room . "</p><span></span></a>");
	}
	echo ("</div> <!-- " . $room . " -->");
	
}
?>
</div> <!-- container -->
</body>
</html>